/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <string.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <dirent.h>


void convert_stat_64_to_32(struct stat *st,
			   struct stat64 *st64)
{
  st->st_dev = st64->st_dev;
  st->st_ino = st64->st_ino;
  st->st_mode = st64->st_mode;
  st->st_nlink = st64->st_nlink;
  st->st_uid = st64->st_uid;
  st->st_gid = st64->st_gid;
  st->st_rdev = st64->st_rdev;
  st->st_size = st64->st_size;
  st->st_blksize = st64->st_blksize;
  st->st_blocks = st64->st_blocks;
  st->st_atime = st64->st_atime;
  st->st_mtime = st64->st_mtime;
  st->st_ctime = st64->st_ctime;
}


void convert_statfs_64_to_32(struct statfs *st,
				struct statfs64 *st64)
{
  st->f_type = st64->f_type;
  st->f_bsize = st64->f_bsize;
  st->f_blocks = st64->f_blocks;
  st->f_bfree = st64->f_bfree;
  st->f_bavail = st64->f_bavail;
  st->f_files = st64->f_files;
  st->f_ffree = st64->f_ffree;
  st->f_fsid.__val[0] = st64->f_fsid.__val[0];
  st->f_fsid.__val[1] = st64->f_fsid.__val[1];
  st->f_namelen = st64->f_namelen;
  st->f_spare[0] = st64->f_spare[0];
  st->f_spare[1] = st64->f_spare[1];
  st->f_spare[2] = st64->f_spare[2];
  st->f_spare[3] = st64->f_spare[3];
  st->f_spare[4] = st64->f_spare[4];
  st->f_spare[5] = st64->f_spare[5];
}


void convert_dirent_64_to_32(struct dirent *d,
			     struct dirent64 *d64)
{
  d->d_ino = d64->d_ino;
  d->d_off = d64->d_off;
  d->d_reclen = d64->d_reclen;
  d->d_type = d64->d_type;
  strcpy(d->d_name, d64->d_name);
}
