/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFA_UDP_NETWORK_H__
#define __ORFA_UDP_NETWORK_H__


#define __orfa_network_init() orfa_UDP_network_init()
#define __orfa_network_finish() orfa_UDP_network_finish()
#define __orfa_network_connect(x,y) orfa_UDP_network_connect(x,y)
#define __orfa_network_call(x) orfa_UDP_network_call(x)
#define __orfa_network_before_fork() orfa_UDP_network_finish()
#define __orfa_network_after_fork_parent() orfa_UDP_network_init()
#define __orfa_network_after_fork_child() orfa_UDP_network_finish()
#define __orfa_network_before_exec() /* nothing */
#define __orfa_network_after_exec_failed() /* nothing */
#define orfa_aligned_malloc(x) malloc(x)
#define __orfa_register_interval(x,y) /* nothing */
#define __orfa_deregister_interval(x,y) /* nothing */


#include <stdlib.h>

#include "orfa_protocol.h"
#include "orfa_common_network.h"
#include "orfa_client.h"


extern int orfa_UDP_network_init();
extern void orfa_UDP_network_finish();
extern int orfa_UDP_network_connect(char *server_name,
				    struct connection *connection);
extern int orfa_UDP_network_call(struct client_request *req);


#endif /* __ORFA_UDP_NETWORK_H__ */
