/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFA_DIR_H__
#define __ORFA_DIR_H__


#include "orfa_portable.h"
#include "orfa_server.h"


typedef struct orfa_real_dir orfa_real_dir_t;
typedef struct orfa_dir orfa_dir_t;


extern int get_orfa_dir_server(orfa_dir_t *dir,
			       server_t *server,
			       orfa_dir_id_t *dir_id);

extern  orfa_dir_t *get_orfa_dir(orfa_dir_id_t dir_id, server_t server);
extern void put_all_orfa_dir();

extern int is_orfa_dir(orfa_dir_t *dir);

extern void orfa_dir_before_fork();
extern void orfa_dir_after_fork_child();

extern char *orfa_dir_before_exec();
extern void orfa_dir_after_exec_failed();
extern void orfa_dir_after_exec();


#endif /* __ORFA_DIR_H__ */
