/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFA_FD_H__
#define __ORFA_FD_H__


#include "orfa_network.h"

extern int get_orfa_fd_params(int fd,
			      off64_t *new_seek,
			      off64_t *new_size);
extern int set_orfa_fd_params(int fd,
			      off64_t new_seek,
			      off64_t new_size);

extern int get_orfa_fd_server(int fd,
			      server_t *server,
			      orfa_fd_id_t *fd_id);
extern char *get_orfa_fd_file_name(int fd);

extern int get_orfa_fd_flags(int fd);
extern inline int is_append_orfa_fd(int fd) {
  return ( get_orfa_fd_flags(fd) & O_APPEND );
}

extern int orfa_fd_fcntl(int fd, int cmd, long arg);

extern int get_orfa_fd(server_t server,
		       orfa_fd_id_t fd_id,
		       struct portable_stat *stats,
		       const char *file_name,
		       mode_t mode);
extern void put_orfa_fd(int fd);
extern void put_all_orfa_fd();

extern int is_orfa_fd(int fd);

extern void orfa_dup(int oldfd, int newfd);

extern void orfa_fd_before_fork();
extern void orfa_fd_after_fork_child();

extern char *orfa_fd_before_exec();
extern void orfa_fd_after_exec_failed();
extern void orfa_fd_after_exec();


#endif /* __ORFA_FILE_DESCR_H__ */
