/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFA_PATH_H__
#define __ORFA_PATH_H__


#include "orfa_network.h"


extern int is_orfa_pathname(const char *path,
			    char **simplified_path);
extern void orfa_parse_path(const char *path,
		       char **server_name,
		       char **path_on_server);

extern int orfa_fchdir(int fd);
extern int orfa_chdir(const char *path);
extern void unorfa_chdir();

extern int is_orfa_pwd();
extern char *orfa_getcwd(char *buf, size_t size);

extern char *orfa_pwd_before_exec();
extern void orfa_pwd_after_exec_failed();
extern void orfa_pwd_after_exec();


#endif /* __ORFA_PATH_H__ */
