/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFA_REGCACHE_H__
#define __ORFA_REGCACHE_H__


#if REGCACHE_ENABLED
# define orfa_clear_interval orfa_regcache_deregister_interval
# define orfa_use_interval orfa_regcache_use_interval
# define orfa_unuse_interval orfa_regcache_unuse_interval
#else /* ~REGCACHE_ENABLED */
# define orfa_use_interval __orfa_register_interval
# define orfa_unuse_interval __orfa_deregister_interval
#endif /* ~REGCACHE_ENABLED */


extern void orfa_regcache_deregister_interval(void *ptr, unsigned int length);
extern int orfa_regcache_use_interval(void *ptr, unsigned int length);
extern void orfa_regcache_unuse_interval(void *ptr, unsigned int length);


#endif /* __ORFA_REGCACHE_H__ */
