/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFA_SERVER_H__
#define __ORFA_SERVER_H__

#include <stdint.h>

#include "orfa_common_network.h"


typedef int server_t;


extern server_t find_orfa_server(char *name);
extern server_t add_orfa_server(char *name);

extern void set_orfa_server_connection(server_t i, struct connection *connection);
extern struct connection *get_orfa_server_connection(server_t i);

extern void inc_orfa_server_use_count(server_t i);
extern void dec_orfa_server_use_count(server_t i);

#ifdef CONNECTION_ID_ENABLED
extern void set_orfa_server_connection_id(server_t i, connection_id_t id);
extern connection_id_t get_orfa_server_connection_id(server_t i);
#endif /* CONNECTION_ID_ENABLED */

extern char *orfa_server_before_exec();
extern void orfa_server_after_exec_failed();
extern void orfa_server_after_exec();

extern void orfa_server_after_fork_child();


#endif /* __ORFA_SERVER_H__ */
