/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __ORFA_SHARED_H__
#define __ORFA_SHARED_H__


#include <sys/types.h>


extern inline void orfa_update_pid(pid_t pid) { context.pid = pid; }
extern inline void orfa_update_euid(uid_t uid) { context.euid = uid; }
extern inline void orfa_update_egid(gid_t gid) { context.egid = gid; }
extern inline void orfa_update_umask(mode_t umask) { context.umask = umask; }
extern inline void orfa_update_concurrent_mode(int set) { context.concurrent_mode = set; }

extern void orfa_update_pid(pid_t pid);
extern void orfa_update_euid(uid_t uid);
extern void orfa_update_egid(gid_t gid);
extern void orfa_update_umask(mode_t umask);
extern void orfa_update_concurrent_mode(int set);

extern void orfa_before_fork();
extern void orfa_after_fork_failed();
extern void orfa_after_fork_parent();
extern void orfa_after_fork_child();

extern void orfa_before_exec(char **envp, int *lenp, char ***new_envpp);
extern void orfa_after_exec_failed(int old_len, char **new_envp);

extern void orfa_init();
extern void orfa_fini();


#endif /* __ORFA_SHARED_H__ */
