/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <dlfcn.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <utime.h>

#include "orfa_real_calls.h"


/* include real_calls definitions */
#undef REAL_CALLS_EXTERN
#undef REAL_CALLS_STATIC
#undef REAL_CALLS_FIX
#define REAL_CALLS_STATIC
#include "orfa_real_calls_list.h"


/* How to fix these calls ? */
#define FIX(x) real_##x = dlsym(RTLD_NEXT, #x)


/* Have calls been fixed ? */
int real_calls_initialized = 0;


void fix_all_real_calls()
{
  /* fix real_calls value using FIX */
#undef REAL_CALLS_EXTERN
#undef REAL_CALLS_STATIC
#undef REAL_CALLS_FIX
#define REAL_CALLS_FIX
#include "orfa_real_calls_list.h"

  real_calls_initialized = 1;
}
