/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFAS_STD_FS_H__
#define __ORFAS_STD_FS_H__

extern int STD_process_init();
extern void STD_process_finish();

extern void *STD_get_new_fd(int local_fd);
extern void *STD_get_new_dir(void *local_dir);

#ifdef CONNECTION_ID_ENABLED
#include "orfas_network.h"
extern void STD_set_fd_connection_id(void *fd, struct connection_id *id);
extern void STD_set_dir_connection_id(void *dir, struct connection_id *id);
extern void STD_close_file_for_connection_id(struct connection_id *id);
#endif /* ~CONNECTION_ID_ENABLED */

extern int STD_put_old_fd(void *fd);
extern int STD_put_old_dir(void *dir);

extern int STD_get_local_fd_of_fd(void *fd);
extern void *STD_get_local_dir_of_dir(void *dir);


#endif /* __ORFAS_STD_FS_H__ */
