/*
 * ORFA - A user-level remote file system access protocol
 * Copyright (C) 2002 Brice Goglin <Brice.Goglin@ens-lyon.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __ORFAS_QUEUE_H__
#define __ORFAS_QUEUE_H__


extern struct server_request *get_free_request();
extern void put_free_request(struct server_request *req);

extern void queue_ready_request(struct server_request *req);
extern struct server_request *dequeue_ready_request();

extern void queue_done_request(struct server_request *req);
extern struct server_request *dequeue_done_request();

#ifdef AIO_IO
extern void queue_processing_request(struct server_request *req);
extern struct server_request *dequeue_processing_request_for_key(void *key);
#endif


#ifdef NETWORK_GM

#include "orfas_io.h"

extern void queue_not_ready_request(struct server_request *req);
extern struct server_request *dequeue_not_ready_request_for_GM_connection(struct connection *connection);

extern void queue_not_ready_buffer(struct io_vector *vect,
				   struct connection *connection);
extern struct io_vector *dequeue_not_ready_buffer_for_GM_connection(struct connection *connection);

#endif /* GM_NETWORK */


#endif /* __ORFAS_QUEUE_H__ */
